#include "stdafx.h"

void GetFiFoAttributes(HWND hWnd, LPCTSTR szPath) {
	DWORD dwAttrib = GetFileAttributes(szPath);

  if(dwAttrib & FILE_ATTRIBUTE_COMPRESSED) CheckDlgButton(hWnd, IDC_COMPRESSED, BST_CHECKED);
  else CheckDlgButton(hWnd, IDC_COMPRESSED, BST_UNCHECKED);

  if(dwAttrib & FILE_ATTRIBUTE_ENCRYPTED) CheckDlgButton(hWnd, IDC_ENCRYPTED, BST_CHECKED);
  else CheckDlgButton(hWnd, IDC_ENCRYPTED, BST_UNCHECKED);

  if(dwAttrib & FILE_ATTRIBUTE_READONLY) CheckDlgButton(hWnd, IDC_READONLY, BST_CHECKED);
  else CheckDlgButton(hWnd, IDC_READONLY, BST_UNCHECKED);

  if(dwAttrib & FILE_ATTRIBUTE_SYSTEM) CheckDlgButton(hWnd, IDC_SYSTEM, BST_CHECKED);
  else CheckDlgButton(hWnd, IDC_SYSTEM, BST_UNCHECKED);

  if(dwAttrib & FILE_ATTRIBUTE_HIDDEN) CheckDlgButton(hWnd, IDC_HIDDEN, BST_CHECKED);
  else CheckDlgButton(hWnd, IDC_HIDDEN, BST_UNCHECKED);
}

void SetFiFoAttributes(LPCTSTR szPath, BOOL bRead, BOOL bSyst, BOOL bHide) {
	DWORD dwAttrib = GetFileAttributes(szPath);

  if(!(dwAttrib & FILE_ATTRIBUTE_READONLY)) {
     if(bRead) dwAttrib |= FILE_ATTRIBUTE_READONLY;
   }else{
     if(!bRead) dwAttrib &= ~FILE_ATTRIBUTE_READONLY;
  }

  if(!(dwAttrib & FILE_ATTRIBUTE_SYSTEM)) {
     if(bSyst) dwAttrib |= FILE_ATTRIBUTE_SYSTEM;
   }else{
     if(!bSyst) dwAttrib &= ~FILE_ATTRIBUTE_SYSTEM;
  }

  if(!(dwAttrib & FILE_ATTRIBUTE_HIDDEN)) {
     if(bHide) dwAttrib |= FILE_ATTRIBUTE_HIDDEN;
   }else{
     if(!bHide) dwAttrib &= ~FILE_ATTRIBUTE_HIDDEN;
  }

  SetFileAttributes(szPath, dwAttrib);
}