#include "stdafx.h"

   //==========================================================================
  // Recursive Function that will go through ALL of the Files & Sub-Directories
 // ----------------------------------------------- within the Target Directory
//=============================================================================			...ADD 2 BOOLs to Function
int FindAllContents(HANDLE hFindFile, char *szPath, FILETIME ftCreated, FILETIME ftModified, FILETIME ftAccessed, BOOL bChangeAtt, BOOL bBypassAtt, BOOL bRead, BOOL bSyst, BOOL bHide) {
	WIN32_FIND_DATA stFindData;
	char *szCurFilename = (char*)malloc(sizeof(char)*_MAX_PATH);
	char *szCurPathname = (char*)malloc(sizeof(char)*_MAX_PATH);

	strcpy_s(szCurFilename, 1024, szPath);
	strcpy_s(szCurPathname, 1024, szPath);

	  // If "We" Don't Have a Valid (File Handle) Target...
	if((hFindFile == NULL)||(hFindFile == INVALID_HANDLE_VALUE)) { // Start the Search
		sprintf_s(szCurFilename, 1024, "%s\\*.*",szPath); // ---- Look for EveryThing!

		hFindFile = FindFirstFile(szCurFilename, &stFindData);
		if(hFindFile == INVALID_HANDLE_VALUE) return 0; // IF It's Empty...Quit!
	}else{ // -----------------------------------------// IF It's Valid...Look for More!
		if(!FindNextFile(hFindFile, &stFindData)) { //// IF That's the Last Target...
			FindClose(hFindFile); // --------------- // Close the File Handle...
			return 0; // -------------------------- // And Quit...
		}
	}

	strcat_s(szCurPathname, 1024, "\\");
	strcat_s(szCurPathname, 1024, stFindData.cFileName);

	if(stFindData.dwFileAttributes &FILE_ATTRIBUTE_DIRECTORY) { // - IF It's a Folder Then....
		if((!_stricmp(stFindData.cFileName, ".")) || // ...Look Inside, But Avoid the Up-Links
		  (!_stricmp(stFindData.cFileName, "..")) || (!_stricmp(stFindData.cFileName, ""))) {
			// -------------------------------- and Call It Recursively to Check for Contents.
			return FindAllContents(hFindFile, szPath, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);
        }
		
		// call the set function for the found folder
		ChangeFiFoTimes(szCurPathname, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);

		// -------------------------- Call It Recursively to Check for Contents.
		FindAllContents(NULL, szCurPathname, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);
    }

	// control will come here only if the found one is a file

	//  set the date time to the file
	ChangeFiFoTimes(szCurPathname, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);

	// -------------------------------- Call It Recursively to Check for More!
 return FindAllContents(hFindFile, szPath, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);
}