#include "stdafx.h"

char g_szPath[_MAX_PATH+2];
LPTSTR OpenFolderDlg(HWND hWnd) {
	BROWSEINFO binfo;

	binfo.hwndOwner = hWnd;
    binfo.pidlRoot = NULL;
    binfo.pszDisplayName = g_szPath;
    binfo.lpszTitle = "Choose a Folder";
    binfo.ulFlags = 0;
    binfo.lpfn = NULL;
    binfo.lParam = 0;

  CoInitialize(0);
  LPITEMIDLIST  piList = SHBrowseForFolder(&binfo);
  SHGetPathFromIDList(piList, g_szPath);
 return g_szPath;
}

LPTSTR OpenFileDlg(HWND hWnd) {
	OPENFILENAME ofn;  // common dialog box structure
	char szFile[_MAX_PATH+2]; // buffer for file name

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFile = szFile;
	//
	// Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
	// use the contents of szFile to initialize itself.
	//
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "All Files *.*\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST |OFN_EXPLORER| OFN_FILEMUSTEXIST | OFN_FORCESHOWHIDDEN | OFN_HIDEREADONLY;

  // Display the Open dialog box. 
  GetOpenFileName(&ofn);
  strcpy_s(g_szPath, ofn.lpstrFile);
return g_szPath;
}